// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.3
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
namespace Fund;

interface

uses Esmf;

type
  
  ISocioEconomic2RegionalWelfare = public interface
    property inputpopulation: IParameter2Dimensional<Timestep, Fund.CommonDimensions.Region, double> read;
    
    property population: IVariable2Dimensional<Timestep, Fund.CommonDimensions.Region, double> read;
  end; 
  
  SocioEconomic2RegionalWelfare = public class
  private
  protected
  public
    method Run(clock: Clock; state: ISocioEconomic2RegionalWelfare);    
  end;
  
implementation

method SocioEconomic2RegionalWelfare.Run(clock: Clock; state: ISocioEconomic2RegionalWelfare); 
begin
  var s:=state;
  var t:=clock.Current;
       
  for each r: Fund.CommonDimensions.Region in Enum.GetValues(typeof(Fund.CommonDimensions.Region)) do
  begin    
    s.population[t,r]:=s.inputpopulation[t,r]*1000000;
  end;
  
end;

end.