// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.3
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
namespace Fund;

interface

type
  LegacyRegionNames = public class
  private
    class _names: Array of String;
    class method GetName(i: Integer): String;
  protected
  public
    class constructor;
    
    class property Name[i: Integer]: String read GetName;
  end;
  
implementation

class constructor LegacyRegionNames; 
begin
  _names:=new String[16]; 
  
  for each r: Fund.CommonDimensions.Region in Enum.GetValues(typeof(Fund.CommonDimensions.Region)) do
  begin
    var indexr:=ord(r);
    _names[indexr-1]:=Enum.GetName(typeof(Fund.CommonDimensions.Region),r);
  end; 
end;

class method LegacyRegionNames.GetName(i: Integer): String; 
begin
  Result:=_names[i-1];
end;

end.