// Climate Framework for Uncertainty, Negotiation and Distribution
// Version 3.3
// (c) David Anthoff and Richard S.J. Tol
// http://www.fund-model.org
namespace Fund;

interface

uses System.Collections.Generic;

type
  YearParameterConnector = public class (Esmf.IParameter1Dimensional<Esmf.Timestep,double>)
  private
    _values: array of Double;
  protected
    method GetItem(t: Esmf.Timestep): Double;
  public
    constructor(param: Parameters; name: string);
    
    property Item[t: Esmf.Timestep]: double read GetItem; default;
    method GetEnumerator: System.Collections.Generic.IEnumerable<Esmf.Parameter1DimensionalMember<Esmf.Timestep,System.Double>>;
  end;
  
implementation

method YearParameterConnector.GetItem(t: Esmf.Timestep): Double; 
begin
  Result:=_values[t.Value];      
end;

constructor YearParameterConnector(param: Parameters; name: string); 
begin
  _values:=new double[LegacyConstants.NYear+1];
  
  for i:integer:=0 to LegacyConstants.NYear do
  begin
    _values[i]:=param.GetItemByYear(i, name);
  end;    
end;

method YearParameterConnector.GetEnumerator: System.Collections.Generic.IEnumerable<Esmf.Parameter1DimensionalMember<Esmf.Timestep,System.Double>>;
begin
  raise new NotImplementedException;
end;

end.